/*
 * This file is part of din.
 *
 * din is copyright (c) 2006 - 2012 S Jagannathan <jag@dinisnoise.org>
 * For more information, please visit http://dinisnoise.org
 *
 * din is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 2 of the License, or
 * (at your option) any later version.
 *
 * din is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
 * FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
 * for more details.
 *
 * You should have received a copy of the GNU General Public License along
 * with din.  If not, see <http://www.gnu.org/licenses/>.
 *
*/
#ifndef __ui_list
#define __ui_list

#include "ui.h"
#include "font_editor.h"
#include "label_field_slider.h"
#include "checkbutton.h"
#include "ticker_tape.h"
#include "console.h"
#include "fader.h"

struct curve_editor;

/*struct rate_handler : val_handler<int> {
	std::stringstream ss;
	void operator() (const int& f) {
		ss.clear ();
		ss << "set-bpm fm " << f;
		cons (ss.str());
	}
};

struct depth_handler : val_handler<int> {
	std::stringstream ss;
	void operator() (const int& f) {
		ss.clear ();
		ss << "set-var fmd " << f;
		cons (ss.str());
	}
};*/

struct din;

struct voice__listener : state_listener {
	void changed (const checkbutton& cb);
};

struct gater__listener : state_listener {
	void changed (const checkbutton& cb);
};

struct delay__listener : state_listener {
	void changed (const checkbutton& cb);
};

struct compress__listener : state_listener {
	void changed (const checkbutton& cb);
};

struct ui_list : ui {

  std::vector<ui*> uis;
  ui *current, *prev;

  curve_editor* crved;

  font_editor fed;

  static const int MAX_EDITORS = 8;
  static const int key [MAX_EDITORS];
  static ui* ed [MAX_EDITORS];

	float esct;

  ui_list ();

  void set_current (ui* u, int ised = 1);
  bool set_editor (const std::string& name, int screen);

  bool handle_input ();
  void draw ();
	
	// gui widgets
	//
  std::vector<widget*> widgets;

  checkbutton w_voice;
  voice__listener vlis;
	fader fdr_voice;
	
  checkbutton w_gater;
  gater__listener glis;
  fader fdr_gater;
  void flash_gater ();
  
  checkbutton w_delay;
  delay__listener dlis;
  fader fdr_delay;
  
  checkbutton w_compress;
  compress__listener clis;
  
  ticker_tape w_ticker;
  
  void setup_widgets ();
  void update_widgets ();
	float eval_fade (fader& fdr, checkbutton& cb);

};


#endif
