#include "label.h"
#include "font.h"
#include "viewwin.h"

using namespace std;

extern int mousex, mousey;
extern viewport view;
extern int lmb;

label::label (const string& t) {
	lmb_clicked = 0;
	move = 0;
	set_text (t);
}

void label::set_text (const string& t) {
	text = t;
	int w = get_char_width (text), h = get_max_char_height (text);
	const box<int>& e = get_extents ();
	set_extents (e.left, e.bottom, e.left + w, e.bottom + h);
}

void label::draw () {
	widget::draw ();
	int x, y; get_pos (x, y);
	draw_string (text, x, y);
}

int label::handle_input () {
	
	int x = mousex, y = view.ymax - mousey;
	
	widget::handle_input ();
	
	int ret = 0;
	if (lmb) {
		if (lmb_clicked == 0) {
			if (move) {
				move = 0;
				widget::focus = 0;
				ret = 1;
			}
			else if (hovering()) { 
				move = 1;
				widget::focus = this;
				prevx = x; prevy = y;
				ret = 1;
			}
			lmb_clicked = 1;
		}
	} else {
		if (move) {
			int dx = mousex - prevx, dy = y - prevy;
				widget::move (dx, dy);
			prevx = x; prevy = y;
			ret = 1;
		}
		lmb_clicked = 0;
	}	
	
	return ret;

}

void label::update () {
	set_text (text);
}
